summaryrefslogtreecommitdiffstats
path: root/libexec/container/log
diff options
context:
space:
mode:
Diffstat (limited to 'libexec/container/log')
-rwxr-xr-xlibexec/container/log143
1 files changed, 143 insertions, 0 deletions
diff --git a/libexec/container/log b/libexec/container/log
new file mode 100755
index 0000000..a18c421
--- /dev/null
+++ b/libexec/container/log
@@ -0,0 +1,143 @@
+#!/bin/sh
+
+# Copyright (C) 2014-2021 Daniel Baumann <daniel.baumann@open-infrastructure.net>
+#
+# SPDX-License-Identifier: GPL-3.0+
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+set -e
+
+PROJECT="open-infrastructure"
+PROGRAM="container"
+COMMAND="$(basename ${0})"
+
+LOG="/var/log/${PROJECT}/${PROGRAM}.log"
+
+Parameters ()
+{
+ GETOPT_LONGOPTIONS="name:,date:,"
+ GETOPT_OPTIONS="n:,d:,"
+
+ PARAMETERS="$(getopt --longoptions ${GETOPT_LONGOPTIONS} --name=${COMMAND} --options ${GETOPT_OPTIONS} --shell sh -- ${@})"
+
+ if [ "${?}" != "0" ]
+ then
+ echo "'${COMMAND}': getopt exit" >&2
+ exit 1
+ fi
+
+ eval set -- "${PARAMETERS}"
+
+ while true
+ do
+ case "${1}" in
+ -d|--date)
+ DATE="${2}"
+ shift 2
+ ;;
+
+ -n|--name)
+ NAME="${2}"
+ shift 2
+ ;;
+
+ -u|--user)
+ USER="${2}"
+ shift 2
+ ;;
+
+ --)
+ shift 1
+ break
+ ;;
+
+ *)
+ echo "'${COMMAND}': getopt error" >&2
+ exit 1
+ ;;
+ esac
+ done
+}
+
+Usage ()
+{
+ echo "Usage: ${PROGRAM} ${COMMAND} [-n|--name NAME] [-d|--date DATE|today|today-N|yesterday] [-u|--user USER]" >&2
+ exit 1
+}
+
+Parameters "${@}"
+
+case "${DATE}" in
+ today-*)
+ DAYS="$(echo ${DATE} | awk -F- '{ print $2 }')"
+
+ START="$(date -d "${DAYS} day ago" '+%Y-%m-%d')"
+ END="$(date +%Y-%m-%d)"
+
+ DATE="(${START}"
+
+ while true
+ do
+ DATE="${DATE}|${START}"
+
+ if [ "${START}" = "${END}" ]
+ then
+ break
+ fi
+
+ START="$(date +%Y-%m-%d --date "${START} +1 day")"
+ done
+
+ DATE="${DATE})"
+ ;;
+
+ today)
+ DATE="$(date +%Y-%m-%d)"
+ ;;
+
+ yesterday)
+ DATE="$(date -d '1 day ago' '+%Y-%m-%d')"
+ ;;
+esac
+
+if ls "${LOG}"-*.gz > /dev/null 2>&1
+then
+ LOGS="$(ls ${LOG}-*.gz) ${LOG}"
+else
+ LOGS="${LOG}"
+fi
+
+for LOG in ${LOGS}
+do
+ case "${LOG}" in
+ *.gz)
+ GREP="zgrep"
+ ;;
+
+ *)
+ GREP="grep"
+ ;;
+ esac
+
+ case "${NAME}" in
+ "")
+ ${GREP} -E "^${DATE}" "${LOG}" || true
+ ;;
+
+ *)
+ ${GREP} -E "^${DATE}" "${LOG}" | grep " ${NAME}" || true
+ ;;
+ esac
+done